 ;===================== 
 ;INDEX FOR HEXTOBCD
 ;==============================
 ;1: 24bit hex to bcd transfer
 ;2:8bit hex to bcd transfer
 ;3:8BIT  BCD TO HEX transfer






;===================================
;  24bit hex to bcd transfer
;-----------------------------------
;input:
;      EAL|AX(EAL|AH|AL)
;output:
;       EAX|AX(EAH|EAL|AH|AL)
;===================================

24bithextobcd:
       mvl  018h
       mvf  cnt,f,acce
BCDINI:
       MVF  AL,W,ACCE
       MVF  TMP1,F,ACCE
       MVF  AH,W,ACCE
       MVF  TMP2,F,ACCE
       MVF  EAL,W,ACCE
       MVF  TMP3,F,ACCE
       CLRF AL
       CLRF AH
       CLRF EAL
       CLRF EAH
       CLRF STATUS
 LOOPC1:
       RLFC TMP1,F,ACCE
       RLFC TMP2,F,ACCE
       RLFC TMP3,F,ACCE
       RLFC AL,F,ACCE
       RLFC AH,F,ACCE
       RLFC EAL,F,ACCE
       RLFC EAH,F,ACCE
       DCSZ CNT,F,ACCE
       JMP  ADJDEC1
       RET
ADJDEC1:
       mvl  00h
       mvf  fsr0h,f,acce
       mvl  AL
       mvf  fsr0l,f,ACCE
       call ADJBCD1
       MVL  AH
       MVF  FSR0L,F,ACCE
       CALL ADJBCD1
       MVL  EAL
       MVF  FSR0L,F,ACCE
       CALL ADJBCD1
       MVL  EAH
       MVF  FSR0L,F,ACCE
       CALL ADJBCD1

       JMP  LOOPC1 
       
 ADJBCD1:
       mvl  03h
       ADDF INDF0,W
       MVF  TMP0,F,ACCE
       BTSZ  TMP0,3
       MVF   INDF0,F,ACCE
       MVL    030H       
       ADDF  INDF0,W
       MVF   TMP0,F,ACCE
       BTSZ  TMP0,7
       MVF   INDF0,F,ACCE
       RET

;===================================
;  8bit hex to bcd transfer
;-----------------------------------
;input:
;      AL
;output:
;      AX(AH|AL)
;===================================
8BITHEXTOBCD:
     MVF al,w,acce
     mvf tmp1,F,ACCE
     clrf al
     clrf ah
     clrf status
     mvl  08h
     mvf  cnt,f,acce
     
loopc:
     rlfc tmp1,f,acce
     rlfc al,f,acce
     rlfc ah,f,acce
     DCSZ CNT,F,ACCE
     JMP  ADJDEC
     ret
adjdec:
       mvl  00h
       mvf  fsr0h,f,acce
       mvl  AL
       mvf  fsr0l,f,ACCE
       call ADJBCD
       MVL  AH
       MVF  FSR0L,F,ACCE
       CALL ADJBCD
       jmp  loopc
ADJBCD:
       mvl  03h
       ADDF INDF0,W
       MVF  TMP0,F,ACCE
       BTSZ  TMP0,3
       MVF   INDF0,F,ACCE

       MVL    030H       
       ADDF  INDF0,W
       MVF   TMP0,F,ACCE
       BTSZ TMP0,7
       MVF   INDF0,F,ACCE
       RET
     
;==========================
;8BIT  BCD TO HEX transfer
;--------------------------
;input:
;      AL
;output:
;      Al
;==========================
8bitbcdtohex:
        swpf   AL,w
        ANDL   0FH
        MVF    TMP1,F,ACCE
        MVL    0FH
        ANDF   AL,F,ACCE
        CLRF   STATUS
        RLFC   TMP1,F,ACCE
        RLFC   TMP1,F,ACCE
        RLFC   TMP1,F,ACCE
        RLFC   TMP1,F,ACCE
        ADDF   TMP1,W,ACCE
        ADDF   AL,F,ACCE
        RET

                    
       
       
       
       